$ TITLE(I2C_DEF.ASM)
;*==========================================================*
;*                                                          *
;*         INCLUDE FILE: I2C_DEF.ASM                        *
;*         PACKAGE     : I2C                                *
;*                                                          *
;*==========================================================*

;*----------------------------------------------------------*
;*    This file must be LINKED to each I2C sub function     *
;*----------------------------------------------------------*

    USING(1)

;*==========================================================*
;*    G L O B A L   D A T A   D E C L A R A T I O N S       *
;*==========================================================*
    PUBLIC      I2C_MCB
    PUBLIC      I2C_CTRL
    PUBLIC      I2C_STAT
    PUBLIC      OWN_SLV_ADDR
    PUBLIC      SLV_BUF_PTR

    PUBLIC      I2C_ADDR_1
    PUBLIC      BUF_LEN_1
    PUBLIC      BUF_PTR_1
    PUBLIC      I2C_ADDR_2
    PUBLIC      BUF_LEN_2
    PUBLIC      BUF_PTR_2


;*==========================================================*
;*    G L O B A L   F U N C T I O N   D E C L A R A T I O N *
;*==========================================================*
    PUBLIC      _I2C_INIT_BYTE
    PUBLIC      _I2C_TEST_DEVICE_BYTE
    PUBLIC      _I2C_WRITE_BYTE
    PUBLIC      _I2C_WRITE_SUB_BYTE
    PUBLIC      _I2C_WRITE_SUB_SWINC_BYTE
    PUBLIC      _I2C_WRITE_MEMORY_BYTE
    PUBLIC      _I2C_WRITE_SUB_WRITE_BYTE
    PUBLIC      _I2C_WRITE_SUB_READ_BYTE
    PUBLIC      _I2C_WRITE_COM_WRITE_BYTE
    PUBLIC      _I2C_WRITE_REP_WRITE_BYTE
    PUBLIC      _I2C_WRITE_REP_READ_BYTE
    PUBLIC      _I2C_READ_BYTE
    PUBLIC      _I2C_READ_STATUS_BYTE
    PUBLIC      _I2C_READ_SUB_BYTE
    PUBLIC      _I2C_READ_REP_READ_BYTE
    PUBLIC      _I2C_READ_REP_WRITE_BYTE


;*==========================================================*
;*    G L O B A L   F U N C T I O N   D E F I N I T I O N S *
;*==========================================================*
    I2C_MCB_DATA   SEGMENT DATA
    RSEG           I2C_MCB_DATA

    _I2C_INIT_BYTE:
        OWN_SLV_ADDR:   DS      1
        SLV_BUF_PTR:    DS      1


    _I2C_TEST_DEVICE_BYTE:
    _I2C_WRITE_BYTE:
    _I2C_WRITE_SUB_BYTE:
    _I2C_WRITE_SUB_SWINC_BYTE:
    _I2C_WRITE_MEMORY_BYTE:
    _I2C_WRITE_SUB_WRITE_BYTE:
    _I2C_WRITE_SUB_READ_BYTE:
    _I2C_WRITE_COM_WRITE_BYTE:
    _I2C_WRITE_REP_WRITE_BYTE:
    _I2C_WRITE_REP_READ_BYTE:
    _I2C_READ_BYTE:
    _I2C_READ_STATUS_BYTE:
    _I2C_READ_SUB_BYTE:
    _I2C_READ_REP_READ_BYTE:
    _I2C_READ_REP_WRITE_BYTE:

        I2C_MCB:        DS      6
            I2C_ADDR_1          DATA    I2C_MCB+0
            BUF_LEN_1           DATA    I2C_MCB+1
            BUF_PTR_1           DATA    I2C_MCB+2
            I2C_ADDR_2          DATA    I2C_MCB+3
            BUF_LEN_2           DATA    I2C_MCB+4
            BUF_PTR_2           DATA    I2C_MCB+5


    I2C_STAT_DATA  SEGMENT DATA BITADDRESSABLE
    RSEG           I2C_STAT_DATA

    I2C_CTRL:           DS      1
    I2C_STAT:           DS      1

    END
