$TITLE(I2C_Init command)
;*==========================================================*
;*                                                          *
;*         SOURCE FILE : I2C_INIT.ASM                       *
;*         PACKAGE     : I2C                                *
;*                                                          *
;*==========================================================*
$DEBUG


;*==========================================================*
;*    I N C L U D E S                                       *
;*==========================================================*


;*==========================================================*
;*    L O C A L   S Y M B O L   D E C L A R A T I O N S     *
;*==========================================================*
    RETRIES         SET     R3

$NOLIST
$INCLUDE(REG751.H)
$INCLUDE(I2C_DATA.GLO)
$INCLUDE(I2C_DATA.LOC)
$LIST


;*==========================================================*
;*    G L O B A L   F U N C T I O N   D E F I N I T I O N S *
;*==========================================================*
  PUBLIC _I2C_INIT

;*==========================================================*
;*    C O D E   S E G M E N T                               *
;*==========================================================*
    I2C_DRIVER SEGMENT CODE
    RSEG I2C_DRIVER

;*MPF:::I2C::I2C_INIT.ASM:I2C_INIT==========================*
;*                                                          *
;* FUNCTION NAME:      I2C_INIT                             *
;* PACKAGE:            I2C                                  *
;* DESCRIPTION:                                             *
;*  Initialize I2C interface: set SDA & SCL, enable time out*
;*  timer, allow 16 MHz (CT1,CT0 = 0). Set the number of    *
;*  retries (max 7) into the I2C_STAT. Bit 7,6 and 5 of the *
;*  I2C_STAT contain the number of retries. Those bits may  *
;*  not be changed during the IC routines.                 *
;*                                                          *
;* INPUT:                                                   *
;*   Before calling I2C_INIT the main program must take care*
;*   that the correct parameters are available in           *
;*   OWN_SLV_ADDR, SLV_BUF_PTR and _I2C_INIT_BYTE+2, this   *
;*   is done automatically when using C, PL/M or the pre-   *
;*   defined assembler macro (available in I2C_MAC.DEF)     *
;*                                                          *
;* OUTPUT:                                                  *
;*   inialized IC and retry number in I2C_STAT 7..5        *
;*                                                          *
;*EMP=======================================================*
_I2C_INIT:
        MOV     I2CFG,#I2C_ENABLE     ;CLR TIRUN, CLR MASTRQ
        SETB    ETI
        SETB    EI2
        SETB    EA                    ;enable interrupts
        ANL     OWN_SLV_ADDR,#0FEH    ;save slv addr bit 0=0
        MOV     I2C_STAT,_I2C_INIT_BYTE+2
        ANL     I2C_STAT,#07H         ;I2C_STAT = retries
        MOV     I2CON,#I2C_RELEASE
        RET


;*==========================================================*
;*    H I S T O R Y                                         *
;*==========================================================*
;*                                                          *
;* 03-07-91    J.C. Pijnenburg  original version            *
;*                                                          *
;*==========================================================*
        END
